> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/dsx-air/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.nvidia.com/dsx-air/_mcp/server.

# Create a node from a system node template

POST https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/from-system-node/
Content-Type: application/json

Adds a new node to the specified simulation based on a system node template.

**Required scope:** `air:simulation_edit` (roles: `air_org_admin`, `air_user`)

Reference: https://docs.nvidia.com/dsx-air/api-reference/nodes/api-v-3-simulations-nodes-from-system-node-create

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Body (application/json)

This endpoint expects an object.

- `system_node` (string, required) — The system node template to create a node from.
- `name` (string, required) — The hostname of the node; this must be unique.
- `simulation` (string, required) — The simulation to add the node to.
- `image` (string, optional) — The image representing the operating system of the node.
- `cpu` (integer, optional) — Number of CPU cores.
- `memory` (integer, optional) — RAM, in MiB.
- `storage` (integer, optional) — Disk space, in GB.
- `pos_x` (integer, optional) — The horizontal coordinate position in the UI.
- `pos_y` (integer, optional) — The vertical coordinate position in the UI.
- `labels` (object, optional) — Labels which can be specified on the node. Fields not specified in the payload schema will be completely ignored. If updating, the data provided will completely replace existing labels: attempting to PATCH specific labels will delete the other labels.
  - `group` (string, optional) — The group of the node.
  - `model` (string, optional) — The model of the node.
  - `sku` (string, optional) — The SKU of the node.
  - `rack_name` (string, optional) — The name of the rack the node is part of.
  - `rack_unit` (integer, optional) — The unit number within a rack for the node.
  - `scalable_unit` (integer, optional) — The scalable unit number that the node belongs to.
  - `rail_index` (integer, optional) — The rail index that the node belongs to.
  - `data_hall` (string, optional) — The name of the data hall that the node is part of.
  - `tray_index` (integer, optional) — The tray index of the node.
  - `role` (string, optional) — The role of the node, e.g. leaf.
  - `pod` (integer, optional) — The pod number that the node belongs to.
  - `superspine_group` (integer, optional) — The superspine group number that the node belongs to.
  - `plane_id` (integer, optional) — Plane identifier in a multi-plane fabric.
- `metadata` (string, optional, nullable) — Custom metadata as a JSON string. This field does not affect the runtime of the node or simulation. It is provided for clients to store metadata about the node for their own purposes.
- `advanced` (object, optional) — Advanced configuration associated with the node.
  - `nic_model` (enum, optional, default: virtio) — Indicates the model to use for the node's network interfaces. * `virtio` - VirtIO * `e1000` - Intel E1000
    - Allowed values: `virtio`, `e1000`
  - `cpu_mode` (enum, optional, default: custom) — Indicates the CPU mode of the node. Can only be set for entities without an `emulation_type` set. * `custom` - Custom CPU mode which can include custom CPU options. * `host-model` - CPU mode which attempts to select a CPU model resembling the hypervisor's CPU model as closely as possible. * `host-passthrough` - CPU mode which exposes all details of the hypervisor's CPU model.
    - Allowed values: `custom`, `host-model`, `host-passthrough`
  - `cpu_options` (list of enum, optional) — Indicates the CPU options of the node. CPU mode must be set to `custom` for CPU options to be used. Can only be set for entities without an `emulation_type` set.
    - Allowed values: `ssse3`, `sse4.1`, `sse4.2`, `popcnt`
  - `secureboot` (boolean, optional, default: false) — Indicates whether the node should perform a SecureBoot. UEFI must be enabled for SecureBoot to be used. Can only be set for entities without an `emulation_type` set.
  - `uefi` (boolean, optional, default: false) — Indicates whether the node should use UEFI. Can only be set for entities without an `emulation_type` set.
  - `boot` (list of enum, optional, default: hd) — Indicates how the node should boot. Accepts either a single device (legacy form, e.g. 'hd' or 'network') or a list of 1..3 unique devices for ordered fall-through (e.g. ['hd', 'network']).
    - Allowed values: `hd`, `network`, `cdrom`
- `cdrom` (object, optional, nullable) — CD-ROM assignment for this node. Provide `{"image": <id>}` to attach or replace the CD-ROM image, or `null` to eject.
  - `image` (string, required) — Image to insert into the node CD-ROM drive.
- `storage_pci` (map from string to object, optional, nullable) — Storage PCI elements associated with the node.
  - `type` (enum, required) — Type of the storage PCI device * `NVME` - NVMe SSD Drive
    - Allowed values: `NVME`
  - `size` (integer, required) — Size of the storage PCI device in GB
  - `name` (string, optional) — Name of the storage PCI device. If not provided, a default name will be assigned in the format `nvme-<index+1>`. The name must contain only letters, numbers, and hyphens and be less than 20 characters
- `management_mac` (string, optional) — Write-only legacy alias for the `eth0` entry of `management_interfaces`. The MAC address of the management interface.
- `management_ip` (string, optional) — Write-only legacy alias for the `eth0` entry of `management_interfaces`. The IPv4 address of the management interface.
- `management_interfaces` (map from string to object, optional) — Dict mapping interface names (e.g. "eth0", "eth1") to management address info with optional keys "ip" (IPv4) and "mac_address". Mutually exclusive with management_ip and management_mac.
  - `ip` (string, required, nullable) — IPv4 address for this management interface on the OOB network. Must be within 192.168.0.0/16 and not end in .255 (broadcast). Set to `null` to opt this interface out of OOB-managed DHCP (interface is still wired to the leaf switch, but no ManagementAddress or dhcpd host entry is created).
  - `mac_address` (string, required) — Unicast MAC address for this management interface.

## Response

### 201

- `id` (string, required)
- `created` (datetime, required)
- `modified` (datetime, required)
- `name` (string, required) — The hostname of the node; this must be unique.
- `simulation` (string, required)
- `image` (string, required) — The image representing the operating system of the node.
- `category` (enum or enum, required) — The Air specific category the node belongs to. * `` - None * `SERVER` - Server * `SWITCH` - Switch * `OOB_SERVER` - OOB Management Server * `OOB_SWITCH` - OOB Management Switch
- `state` (enum, required) — The state of the node w.r.t. the simulation life cycle. * `INACTIVE` - Inactive * `BOOTING` - Booting * `ACTIVE` - Active * `SHUTTING_DOWN` - Shutting down * `ERROR` - Error * `REBUILDING` - Rebuilding
  - Allowed values: `INACTIVE`, `BOOTING`, `ACTIVE`, `SHUTTING_DOWN`, `ERROR`, `REBUILDING`
- `status_from_worker` (string, required) — The last known status of the node reported by the worker. This is the libvirt status of the VM/container.
- `split_options` (any, required, nullable) — A list of possible split options for interfaces for this node
- `cloud_init` (object, required) — Cloud-Init assignment for this node, if any.
  - `user_data_name` (string, required) — Name of the assigned user-data config.
  - `meta_data_name` (string, required) — Name of the assigned meta-data config.
  - `user_data` (string, optional, nullable) — User data config to assign to the node. Supported MIME types are based on the operating system's `cloud-init` service version.
  - `meta_data` (string, optional, nullable) — Meta data config to assign to the node (specific to NoCloud datasource).
- `cpu` (integer, optional) — Number of CPU cores.
- `memory` (integer, optional) — RAM, in MiB.
- `storage` (integer, optional) — Disk space, in GB.
- `pos_x` (integer, optional) — The horizontal coordinate position in the UI.
- `pos_y` (integer, optional) — The vertical coordinate position in the UI.
- `labels` (object, optional) — Labels which can be specified on the node. Fields not specified in the payload schema will be completely ignored. If updating, the data provided will completely replace existing labels: attempting to PATCH specific labels will delete the other labels.
  - `group` (string, optional) — The group of the node.
  - `model` (string, optional) — The model of the node.
  - `sku` (string, optional) — The SKU of the node.
  - `rack_name` (string, optional) — The name of the rack the node is part of.
  - `rack_unit` (integer, optional) — The unit number within a rack for the node.
  - `scalable_unit` (integer, optional) — The scalable unit number that the node belongs to.
  - `rail_index` (integer, optional) — The rail index that the node belongs to.
  - `data_hall` (string, optional) — The name of the data hall that the node is part of.
  - `tray_index` (integer, optional) — The tray index of the node.
  - `role` (string, optional) — The role of the node, e.g. leaf.
  - `pod` (integer, optional) — The pod number that the node belongs to.
  - `superspine_group` (integer, optional) — The superspine group number that the node belongs to.
  - `plane_id` (integer, optional) — Plane identifier in a multi-plane fabric.
- `metadata` (string, optional, nullable) — Custom metadata as a JSON string. This field does not affect the runtime of the node or simulation. It is provided for clients to store metadata about the node for their own purposes.
- `advanced` (object, optional) — Advanced configuration associated with the node.
  - `nic_model` (enum, optional, default: virtio) — Indicates the model to use for the node's network interfaces. * `virtio` - VirtIO * `e1000` - Intel E1000
    - Allowed values: `virtio`, `e1000`
  - `cpu_mode` (enum, optional, default: custom) — Indicates the CPU mode of the node. Can only be set for entities without an `emulation_type` set. * `custom` - Custom CPU mode which can include custom CPU options. * `host-model` - CPU mode which attempts to select a CPU model resembling the hypervisor's CPU model as closely as possible. * `host-passthrough` - CPU mode which exposes all details of the hypervisor's CPU model.
    - Allowed values: `custom`, `host-model`, `host-passthrough`
  - `cpu_options` (list of enum, optional) — Indicates the CPU options of the node. CPU mode must be set to `custom` for CPU options to be used. Can only be set for entities without an `emulation_type` set.
    - Allowed values: `ssse3`, `sse4.1`, `sse4.2`, `popcnt`
  - `secureboot` (boolean, optional, default: false) — Indicates whether the node should perform a SecureBoot. UEFI must be enabled for SecureBoot to be used. Can only be set for entities without an `emulation_type` set.
  - `uefi` (boolean, optional, default: false) — Indicates whether the node should use UEFI. Can only be set for entities without an `emulation_type` set.
  - `boot` (list of enum, optional, default: hd) — Indicates how the node should boot. Accepts either a single device (legacy form, e.g. 'hd' or 'network') or a list of 1..3 unique devices for ordered fall-through (e.g. ['hd', 'network']).
    - Allowed values: `hd`, `network`, `cdrom`
- `cdrom` (object, optional, nullable) — CD-ROM assignment for this node. Provide `{"image": <id>}` to attach or replace the CD-ROM image, or `null` to eject.
  - `image` (string, required) — Image to insert into the node CD-ROM drive.
- `storage_pci` (map from string to object, optional, nullable) — Storage PCI elements associated with the node.
  - `type` (enum, required) — Type of the storage PCI device * `NVME` - NVMe SSD Drive
    - Allowed values: `NVME`
  - `size` (integer, required) — Size of the storage PCI device in GB
  - `name` (string, optional) — Name of the storage PCI device. If not provided, a default name will be assigned in the format `nvme-<index+1>`. The name must contain only letters, numbers, and hyphens and be less than 20 characters
- `management_interfaces` (map from string to object, optional) — Dict mapping interface names (e.g. "eth0", "eth1") to management address info with optional keys "ip" (IPv4) and "mac_address". Mutually exclusive with management_ip and management_mac.
  - `ip` (string, required, nullable) — IPv4 address for this management interface on the OOB network. Must be within 192.168.0.0/16 and not end in .255 (broadcast). Set to `null` to opt this interface out of OOB-managed DHCP (interface is still wired to the leaf switch, but no ManagementAddress or dhcpd host entry is created).
  - `mac_address` (string, required) — Unicast MAC address for this management interface.

## Errors

### 400 Bad Request Error

- `detail` (string, required) — Description of an error.
- `request_id` (string, required, nullable) — ID assigned to the request which encountered the error. Should be provided when opening a support case.
- `type` (enum, required) — Specific type of a 400 error. * `PROTECTED` - Instance may not be deleted as it is being referenced by other instances. * `VALIDATION` - Validation errors encountered during payload processing.
  - Allowed values: `PROTECTED`, `VALIDATION`
- `protected_instances` (list of object, optional) — Instances which bar the current instance from being deleted. Only defined when `type` is set to `PROTECTED`.
  - `id` (string, required) — ID of the instance.
  - `type` (string, required) — Type of the instance.
- `validation_errors` (map from string to list of object or object or map from string to any or list of object, optional) — Validation errors encountered during payload processing. Only defined when `type` is set to `VALIDATION`.

### 403 Forbidden Error

- `detail` (string, required) — Description of an error.
- `request_id` (string, required, nullable) — ID assigned to the request which encountered the error. Should be provided when opening a support case.

### 500 Internal Server Error

- `request_id` (string, required, nullable) — ID assigned to the request which encountered the error. Should be provided when opening a support case.
- `code` (string, required) — Error code which identifies the error. Should be provided when opening a support case.
- `detail` (string, optional, default: An unexpected error has occurred. Please contact NVIDIA Air support for further assistance.) — Description of an error.

## Examples

**Request**

```json
{
  "system_node": "string",
  "name": "string",
  "simulation": "string"
}
```

**Response**

```json
{
  "id": "string",
  "created": "2024-01-15T09:30:00Z",
  "modified": "2024-01-15T09:30:00Z",
  "name": "string",
  "simulation": "string",
  "image": "string",
  "category": "SERVER",
  "state": "INACTIVE",
  "status_from_worker": "string",
  "split_options": null,
  "cloud_init": {
    "user_data_name": "string",
    "meta_data_name": "string",
    "user_data": "string",
    "meta_data": "string"
  },
  "cpu": 1,
  "memory": 1,
  "storage": 1,
  "pos_x": 1,
  "pos_y": 1,
  "labels": {
    "group": "string",
    "model": "string",
    "sku": "string",
    "rack_name": "string",
    "rack_unit": 1,
    "scalable_unit": 1,
    "rail_index": 1,
    "data_hall": "string",
    "tray_index": 1,
    "role": "string",
    "pod": 1,
    "superspine_group": 1,
    "plane_id": 1
  },
  "metadata": "string",
  "advanced": {
    "nic_model": "virtio",
    "cpu_mode": "custom",
    "cpu_options": [
      "ssse3"
    ],
    "secureboot": false,
    "uefi": false,
    "boot": [
      "hd"
    ]
  },
  "cdrom": {
    "image": "string"
  },
  "storage_pci": {},
  "management_interfaces": {}
}
```

**SDK Code**

```python
import requests

url = "https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/from-system-node/"

payload = {
    "system_node": "string",
    "name": "string",
    "simulation": "string"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/from-system-node/';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"system_node":"string","name":"string","simulation":"string"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/from-system-node/"

	payload := strings.NewReader("{\n  \"system_node\": \"string\",\n  \"name\": \"string\",\n  \"simulation\": \"string\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/from-system-node/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"system_node\": \"string\",\n  \"name\": \"string\",\n  \"simulation\": \"string\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/from-system-node/")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"system_node\": \"string\",\n  \"name\": \"string\",\n  \"simulation\": \"string\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/from-system-node/', [
  'body' => '{
  "system_node": "string",
  "name": "string",
  "simulation": "string"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/from-system-node/");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"system_node\": \"string\",\n  \"name\": \"string\",\n  \"simulation\": \"string\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "system_node": "string",
  "name": "string",
  "simulation": "string"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/from-system-node/")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```